freeslot(
"sfx_HMSNOB",
"sfx_sfdsh",
"sfx_sdsh",
"sfx_thokc",
"sfx_bldash",
"sfx_gbost",
"sfx_gwalk",
"sfx_grun",
"sfx_grav",
"sfx_cance",
"sfx_strs",
"MT_GRAVEEFFECTWAY",
"S_PLAY_GALACTICJUMP"
)

for i = 1,5
    freeslot("SKINCOLOR_SUPERGALAXY"..i)
end

skincolors[SKINCOLOR_SUPERGALAXY1] = {
	name = "Super Galaxy 1",
	ramp = {00, 00, 00, 00, 00, 252, 252, 252, 176, 176, 176, 177, 177, 192, 193, 193},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPERGALAXY2] = {
	name = "Super Galaxy 2",
	ramp = {00, 00, 00, 00, 252, 252, 176, 176, 177, 177, 192, 192, 192, 193, 194, 194},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPERGALAXY3] = {
	name = "Super Galaxy 3",
	ramp =	{00, 00, 00, 252, 176, 177, 177, 192, 192, 192, 193, 193, 194, 194, 195, 195},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPERGALAXY4] = {
	name = "Super Galaxy 4",
	ramp = {252, 176, 176, 177, 177, 192, 192, 192, 193, 193, 194, 194, 195, 195, 196, 196},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPERGALAXY5] = {
	name = "Super Galaxy 5",
	ramp =  {176, 177, 177, 192, 192, 192, 193, 193, 194, 194, 195, 195, 196, 196, 197, 197},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}






































mobjinfo[MT_GRAVEEFFECTWAY] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 20*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then P_RemoveMobj(mo) return end
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	mo.angle = mo.target.angle
	if mo.target.player and mo.target.player.valid then
		mo.angle = mo.target.player.drawangle
	end
	if mo.target.skin and mo.target.skin ~= "" then
		if mo.target.eflags & MFE_VERTICALFLIP
			mo.flags2 = $|MF2_OBJECTFLIP
			mo.eflags = $1|MFE_VERTICALFLIP
		end
		mo.skin = mo.target.skin
	end
	local ofsts_tics = min(TICRATE, leveltime)
	local ofsts = FixedMul((ofsts_tics * FRACUNIT) / TICRATE, FRACUNIT*2)
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	mo.sprite = mo.target.sprite
	mo.sprite2 = mo.target.sprite2
	mo.frame = (mo.target.frame & FF_FRAMEMASK)
	mo.radius = mo.target.radius
	mo.height = mo.target.height
	mo.rollangle = mo.target.rollangle
	mo.flags2 = mo.target.flags2
	mo.spritexoffset = ofsts * (((leveltime%4) >= 2) and -1 or 1)
	if mo.fuse then
		mo.frame = $|(FF_TRANS10 * (10 - min(mo.fuse, 10)))
	end
end, MT_GRAVEEFFECTWAY)
//

local MusicTable = {
    [1] = "csup",
    [2] = "shit"
}

addHook("MusicChange", function(oldname, newname, mflags, looping, position, prefadems, fadeinms)
    if splitscreen
        return
    end
    if not (consoleplayer and consoleplayer.valid)
        return
    end
    local Skin = skins[consoleplayer.skin].name
    if Skin == "gsonic"
        if newname == "_super" then
            newname = MusicTable[P_RandomRange(1, 2)]
        end
        return newname, mflags, looping, position, prefadems, fadeinms
    end
end)

rawset(_G, "runspeed", function(player)
	if twodlevel and not rphys then
		return FixedMul(player.runspeed*2/3, player.mo.scale)
	else
		return FixedMul(player.runspeed, player.mo.scale)
	end
end)

rawset(_G, "GametypeCheck", function(player)
	if G_GametypeHasSpectators()
		if not (gametyperules & (GTR_CAMPAIGN|GTR_SPAWNENEMIES)) and (gametyperules & (GTR_RINGSLINGER|GTR_TAG))
			return true
		end
	end
	return false	
end)

rawset(_G, "TransformationTan", function(player, state, scale, spriteyscale, color)
	local wtf = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
	wtf.state = state
	wtf.blendmode = AST_ADD
	wtf.scale = scale
	wtf.color = color
	wtf.colorized = true
	wtf.spriteyscale = spriteyscale
	return wtf
end)

local function spawnThokParticle(player)
    local mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_IVSP)
    if mo then
        mo.target = player.mo
        mo.color = player.mo.color
    end
end

local function S_SpinDust(p, var, scale)
	local dustcheck
	if var == "Stomp"
		if p.powers[pw_super]
			dustcheck = MT_SUPERSPARK
		else
			dustcheck = MT_SPINDUST
		end
	elseif var == "JumpOnGround"
		dustcheck = MT_SPINDUST
	end
	for i = 1, 32
		local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, dustcheck)
		dust.momz = 1*FRACUNIT*P_MobjFlip(p.mo)
		dust.scale = scale
		P_InstaThrust(dust, i*ANGLE_45, 10*scale)
	end
end

local function PainCheck(player)
	if player.exiting or player.powers[pw_carry] or (player.pflags & PF_STASIS) or (player.mo.state == S_PLAY_SUPER_TRANS1)
	or (player.mo.state == S_PLAY_SUPER_TRANS2) or (player.mo.state == S_PLAY_SUPER_TRANS3) or (player.mo.state == S_PLAY_SUPER_TRANS4)
	or (player.mo.state == S_PLAY_SUPER_TRANS5) or (player.mo.state == S_PLAY_SUPER_TRANS6) or P_PlayerInPain(player) or srb2p or player.mo.checkdamage
	or (player.gotflag or player.gotcrystal) or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
	or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_STUN
		return true
	end
end

local function GravityEffect(player, deathfx)
	local scale = player.mo.scale/2
	if (deathfx != nil)
		scale = deathfx>>1
	else
		deathfx = 4<<FRACBITS
	end
	local dist = FixedMul(deathfx,32)
	local hang = P_RandomRange(0,7) * ANGLE_45
	local vang = P_RandomRange(0,7) * ANGLE_45
	local orb = P_SpawnMobj(
		player.mo.x + (dist * cos(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.y + (dist * sin(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.z + (player.mo.height>>1) + (dist * cos(vang+ANGLE_180)),
		MT_SUPERSPARK
	)
	orb.scale = scale
	orb.momx = ((dist/8) * cos(hang)) + ((dist/8) * sin(vang))
	orb.momy = ((dist/8) * sin(hang)) + ((dist/8) * sin(vang))
	orb.momz = (dist/8) * cos(vang)
	orb.fuse = 8
	orb.color = SKINCOLOR_GALAXY
	orb.colorized = true
	orb.blendmode = AST_ADD
	orb.target = player.mo
	orb.tracer = player.mo
end

local function GalaxyEffect(player, deathfx)
	local scale = player.mo.scale/2
	if (deathfx != nil)
		scale = deathfx>>1
	else
		deathfx = 4<<FRACBITS
	end
	local dist = FixedMul(deathfx,32)
	local hang = P_RandomRange(0,7) * ANGLE_45
	local vang = P_RandomRange(0,7) * ANGLE_45
	local orb = P_SpawnMobj(
		player.mo.x + (dist * cos(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.y + (dist * sin(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.z + (player.mo.height>>1) + (dist * cos(vang+ANGLE_180)),
		MT_THOK
	)
	orb.scale = scale
	orb.momx = ((dist/8) * cos(hang)) + ((dist/8) * sin(vang))
	orb.momy = ((dist/8) * sin(hang)) + ((dist/8) * sin(vang))
	orb.momz = (dist/8) * cos(vang)
	orb.fuse = 8
	orb.color = SKINCOLOR_GALAXY
	orb.colorized = true
	orb.blendmode = AST_ADD
	orb.target = player.mo
	orb.tracer = player.mo
end

local function CancelBullshit(player)
	player.mo.transenable = false
	player.mo.transtimer = 0
	S_StartSound(player.mo, sfx_cance)
	player.mo.graveeffect = false
end

local function GalacticAura(player)
	if not player.mo.transtimer then
        player.mo.transtimer = 0
    end
    if player.mo.transenable == nil then
        player.mo.transenable = false
    end
    if player.mo.graveeffect == nil then
        player.mo.graveeffect = false
    end
	
	if player.mo.pressed == nil then
        player.mo.pressed = false
    end
	if not player.mo.pressed2
		player.mo.pressed2 = false
	end
	if not (player.cmd.buttons & BT_CUSTOM1)
		player.mo.pressed2 = false
	end
    local p = player
    local mo = p.mo
    if player.cmd.buttons & BT_CUSTOM1  
	and player.rings > 0 
	and player.mo.transenable == false 
	and player.mo.graveeffect == false 
	and player.mo.pressed == false
	and not player.mo.pressed2
	and not P_IsObjectOnGround(player.mo)
	and not CBW_Battle then
		if player.mo.graveeffect == true return end
		if player.mo.galaxyenable == true return end
        player.mo.transenable = true
		player.mo.pressed = true
		player.mo.pressed2 = true
    end


    if player.mo.transenable and not player.mo.graveeffect == true  then
        if player.mo.transtimer < 10 * TICRATE then
            if (leveltime % 2 == 0) then
				player.mo.transtimer = $ + 2
            end
        end

        if player.mo.transtimer < 3 * TICRATE and not player.powers[pw_super] then 
            player.mo.momx = 0
            player.mo.momy = 0
            player.mo.momz = 0
        end

        if player.mo.transtimer < 2 * TICRATE and not player.powers[pw_super] then
            GravityEffect(player)
            player.mo.state = S_PLAY_SUPER_TRANS1
            player.mo.frame = A
        end

        if player.mo.transtimer > 2 * TICRATE and not player.powers[pw_super] then
            S_StartSound(player.mo, sfx_grav)
            player.mo.transenable = false
            player.mo.graveeffect = true
			local effect = P_SpawnMobjFromMobj(player.mo,0,0,0, MT_THOK)
			effect.blendmode = AST_ADD
			effect.fuse = 1*TICRATE/2
			effect.color = SKINCOLOR_GALAXY
			effect.state = S_GRAVEAURA1
			effect.destscale = player.mo.scale*2
		elseif player.powers[pw_super]
		    S_StartSound(player.mo, sfx_grav)
            player.mo.transenable = false
            player.mo.graveeffect = true
			local effect = P_SpawnMobjFromMobj(player.mo,0,0,0, MT_THOK)
			effect.blendmode = AST_ADD
			effect.fuse = 1*TICRATE/2
			effect.color = SKINCOLOR_GALAXY
			effect.state = S_GRAVEAURA1
			effect.destscale = player.mo.scale*2
		end	
    end
	if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
	and player.mo.pressed == true
		player.mo.pressed = false
	end
	if player.mo.pressed == true
		player.mo.pressed2 = true
	end
    if player.mo.graveeffect then
		if (leveltime % 8 == 1)
			local flash = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GRAVEEFFECTWAY)
			if flash and flash.valid then
				flash.target = player.mo
				flash.blendmode = AST_ADD
				flash.color = SKINCOLOR_GALAXY
				flash.colorized = true
				flash.fuse = 11
			end
			local dd = P_SpawnGhostMobj(p.mo)
			dd.blendmode = AST_ADD
			dd.fuse = TICRATE/5
			dd.destscale = $*2
			dd.color = SKINCOLOR_GALAXY
			dd.colorized = true
		end
		if (leveltime % 4 == 0) 
			local obf = P_SpawnMobjFromMobj(player.mo,
				P_RandomRange(-50, 50)*FRACUNIT,
				P_RandomRange(-50, 50)*FRACUNIT,
				P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
			obf.fuse = 1*TICRATE/2
			obf.color = SKINCOLOR_GALAXY
			obf.state = S_OBFSGRAVE1
			obf.destscale = 0
		end	
		if leveltime % TICRATE == 0 and not player.powers[pw_super]
			player.rings = $ - 1
			S_StartSound(player.mo, sfx_antiri)
		end	
    end
	if player.cmd.buttons & BT_CUSTOM1
	and player.mo.graveeffect == true
	//or player.rings == 0
	and not player.mo.pressed2
		CancelBullshit(player)
		player.mo.pressed2 = true
	elseif player.rings == 0
		if player.mo.graveeffect == true
			CancelBullshit(player)
		end
	end	
	if player.mo.graveeffect == true then
        player.jumpfactor = skins[player.mo.skin].jumpfactor*5/3
		player.normalspeed = skins[player.mo.skin].normalspeed*3/4
        if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0
        or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0 and not P_IsObjectOnGround(player.mo)
            player.mo.flags = $1|MF_NOGRAVITY 
			if (leveltime % 4 == 0) 
				P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
			end
        elseif not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
        or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0
            player.mo.flags = $ & ~MF_NOGRAVITY
		elseif player.mo.momz == 0 and not player.mo.thokcheck and not P_IsObjectOnGround(player.mo)
			P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
        end
        player.gravitycheck = true
		
    else
        if player.gravitycheck == true
            player.mo.flags = $ & ~MF_NOGRAVITY
             player.jumpfactor = skins[player.mo.skin].jumpfactor
			 player.normalspeed = skins[player.mo.skin].normalspeed
             player.gravitycheck = false
        end
    end
end

local function freezeX(player)
	player.mo.momx = 0
end

local function freezeY(player)
	player.mo.momy = 0
end

local function freezeZ(player)
	player.mo.momz = 0
end
 
local function AuraSex(player)
	if (leveltime % 4 == 0) 
		local effect = P_SpawnMobjFromMobj(player.mo,0,0,0, MT_THOK)
		effect.blendmode = AST_ADD
		effect.fuse = 1*TICRATE/2
		effect.color = SKINCOLOR_GALAXY
		effect.state = S_TRANSAURA1
		effect.destscale = player.mo.scale*2
	end	
end

local function CustomFormAura(player)
	if player.powers[pw_super] then
		if (leveltime % 2 == 0)
			local supersparke = P_SpawnMobj(player.mo.x+(P_RandomRange(-500,500)*player.mo.scale),
			player.mo.y+(P_RandomRange(-500,500)*player.mo.scale),
			player.mo.z+(P_RandomRange(-500/3,500/3)*player.mo.scale),MT_NIGHTSPARKLE)
			supersparke.destscale = 0
			supersparke.scalespeed = player.mo.scale/40
			supersparke.blendmode = AST_ADD
			supersparke.frame = A|FF_FULLBRIGHT
			supersparke.color =	player.mo.color
			supersparke.tics = TICRATE-TICRATE/3
		end
		if (leveltime % 2 == 0)
			local galaxyball = P_SpawnMobj(player.mo.x+(P_RandomRange(-120,120)*player.mo.scale),
			player.mo.y+(P_RandomRange(-80,80)*player.mo.scale),
			player.mo.z+(P_RandomRange(-50/3,200/3)*player.mo.scale),MT_THOK)
			galaxyball.destscale = 0
			galaxyball.state = S_CIRCLEAURA1
			galaxyball.scalespeed = player.mo.scale/10
			galaxyball.blendmode = AST_ADD
			galaxyball.color = player.mo.color
			galaxyball.tics = TICRATE-TICRATE/5
		end
		if (leveltime % 48 == 0)
			local dd = P_SpawnMobjFromMobj(player.mo,0,0,0, MT_THOK)
			dd.blendmode = AST_ADD
			dd.fuse = TICRATE/2
			dd.destscale = $*2
			dd.state = S_BLASTAURA1
			dd.color = SKINCOLOR_GALAXY
			dd.colorized = true
		end
	end
	if not player.powers[pw_super] then 
		player.charflags = SF_NOSKID
		player.mo.galaxyform = false
	end	
end

local function GalaxyForm(player)
	if not player.mo.ifuckedcamera
		player.mo.ifuckedcamera = false
	end
	if player.mo.ifuckedcamera == true
		local skin = skins[player.mo.skin]
		player.camerascale = skin.camerascale*20/10
	else
		local skin = skins[player.mo.skin]
		player.camerascale = skin.camerascale
	end
	if not player.mo.galaxytimer then
        player.mo.galaxytimer = 0
    end
    if player.mo.galaxyenable == nil then
        player.mo.galaxyenable = false
    end
	if player.mo.galaxymusic1 == nil then
		player.mo.galaxymusic1 = false
	end
	if player.mo.galaxyform == nil then
		player.mo.galaxyform = false
	end
	if All7Emeralds(emeralds) and player.cmd.buttons & BT_CUSTOM3 and player.rings >= 50
	and not player.mo.galaxyenable
	and not  player.mo.galaxyform 
	and not player.mo.thokcheck
	and not CBW_Battle then
		player.mo.galaxyenable = true
	end
	
	if player.mo.galaxyenable and not player.mo.galaxyform then
		if player.mo.galaxytimer < 100 * TICRATE then
			if (leveltime % 2 == 0) then
				player.mo.galaxytimer = $ + 5
			end
		end
		
		if player.mo.galaxytimer <= 2 * TICRATE then
			freezeX(player)
			freezeY(player)
			player.drawangle = $ + ANGLE_90 / 10
			player.mo.state = S_PLAY_SPRING
			P_SetObjectMomZ(player.mo, 7*FRACUNIT, false)
        end
		if player.mo.galaxytimer > 2 * TICRATE and player.mo.galaxytimer <=15*TICRATE  then
			freezeZ(player)
			freezeX(player)
			freezeY(player)
		end	
		if player.mo.galaxytimer >= 2 * TICRATE and player.mo.galaxytimer <= 9 * TICRATE
			player.pflags = $ & ~PF_INVIS
			player.mo.state = S_PLAY_SUPER_TRANS1
			player.mo.frame = B
			GalaxyEffect(player)
			AuraSex(player)
		end
		if player.mo.galaxytimer == 2 *TICRATE and player.mo.galaxymusic1 == false then
			player.mo.galaxymusic1 = true
		end
		
		if player.mo.galaxytimer == 9 * TICRATE then
			P_StartQuake(79*FRACUNIT, 3)
			P_FlashPal(player, PAL_WHITE, 3)
			P_NukeEnemies(player.mo, player.mo, RING_DIST)
			S_StartSound(player.mo, sfx_strs)
		end
		
		if player.mo.galaxytimer >=9 * TICRATE and player.mo.galaxytimer <=25*TICRATE  then
			freezeZ(player)
			freezeX(player)
			freezeY(player)
			player.mo.state = S_PLAY_SUPER_TRANS3
			player.mo.frame = C
			player.mo.ifuckedcamera = true
			AuraSex(player)
			if (leveltime % 8 == 1)
				local flash = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GRAVEEFFECTWAY)
				if flash and flash.valid then
				flash.target = player.mo
				flash.blendmode = AST_ADD
				flash.color = player.mo.color
				flash.colorized = true
				flash.fuse = 11
				end
			end
		end	
		if player.mo.galaxytimer >=15 * TICRATE and player.mo.galaxytimer <=25*TICRATE then
			freezeZ(player)
			freezeX(player)
			freezeY(player)
			player.mo.state = S_PLAY_SUPER_TRANS5
			player.mo.frame = G
			if (leveltime % 4 == 0)
				S_StartSound(mo, sfx_s3k7c)
				TransformationTan(player, S_TAN_TRNS31, player.mo.scale*3, 4*FRACUNIT, SKINCOLOR_GALAXY)
				if player == consoleplayer
					P_StartQuake(44*FRACUNIT, 1)
				end
			end
		end
		if player.mo.galaxytimer == 25 * TICRATE
			player.charflags = SF_NOSKID|SF_SUPER
			P_DoSuperTransformation(player)
			player.mo.galaxyform = true
			player.mo.galaxytimer = 0
			player.mo.galaxyenable = false
			player.mo.ifuckedcamera = false
		end
		if player.mo.galaxymusic1 == true then
			S_StartSound(player.mo, sfx_s3ka4)
			player.mo.galaxymusic1 = false
		end	
	end		
end			


addHook("PlayerThink", function(player)
    if not (player.mo and player.mo.valid) then return end
	if not (player.mo.skin == "gsonic") then return end
	if not (player.playerstate == PST_LIVE) then return end
    local mo = player.mo
	local p = player
	//For you TanCharaYp. Because are you confused in one "PlayerThink". Now Make "local function" and all!
	GalacticAura(player)
	CustomFormAura(player)
	GalaxyForm(player)
	//
	local originalspeed = skins[player.mo.skin]
	local frames = 1
	if player.panim == PA_WALK or player.panim == PA_RUN
		frames = skins[player.skin].sprites[player.mo.sprite2].numframes or $
	end
	if player.panim == PA_WALK or player.panim == PA_RUN and (P_IsObjectOnGround(player.mo))
	and not (player.mo.eflags & MFE_TOUCHWATER)
		if (((player.mo.frame & FF_FRAMEMASK) + 1) % max(frames/2, 1) == 0) and player.mo.tics == 1
		and player.mo.state == S_PLAY_WALK
			if ((player.mo.frame & FF_FRAMEMASK)/3) & 1
				if P_IsObjectOnGround(player.mo) then
					S_StartSound(player.mo, sfx_gwalk)
					P_SpawnSkidDust(player, 10*FRACUNIT)
				end	
			else
				if P_IsObjectOnGround(player.mo) then
					S_StartSound(player.mo, sfx_gwalk)
					P_SpawnSkidDust(player, 10*FRACUNIT)
				end	
			end
		elseif not player.powers[pw_super]
			if player.mo.state == S_PLAY_RUN or player.mo.DASHMODESTATE == true then
				if player.speed < 55*FRACUNIT then
					if (leveltime % 5) == 4
						S_StartSound(player.mo, sfx_grun)
						P_SpawnSkidDust(player, 10*FRACUNIT)
					end
				else
					if (leveltime % 3) == 1
						S_StartSound(player.mo, sfx_grun)
						P_SpawnSkidDust(player, 10*FRACUNIT)
					end
				end
			end
		end
	end
	if not (player.mo.checkdamage)
		player.mo.checkdamage = false
	end
	if not (player.mo.thokcheck)
		player.mo.thokcheck = false
	end
	if not (player.mo.spinbtn)
		player.mo.spinbtn = false
	end
	if p.mo.state == S_PLAY_GALACTICJUMP
		if not player.mo.graveeffect
			local dd = P_SpawnGhostMobj(p.mo)
			dd.blendmode = AST_ADD
			dd.fuse = TICRATE/5
			dd.destscale = 0
			dd.colorized = true
			dd.color = player.mo.color
		end	
	end
	if not (player.cmd.buttons & BT_SPIN)
		if not player.mo.thokcheck
			player.mo.spinbtn = false
		end
	end
	if not (p.mo.ghoming)
		p.mo.ghoming = false
	end
	if not (player.mo.maxdashmode)
		player.mo.maxdashmode = false
	end
	if not (p.mo.dustOnGround)
		p.mo.dustOnGround = false
	end
	if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
		player.mo.checkdamage = false
	end
	if P_PlayerInPain(player) or (CBW_Battle and (player.tumble != nil and player.tumble > 0))
	or player.mo.state == S_PLAY_PAIN or player.mo.sprite2 == SPR2_PAIN
		player.mo.checkdamage = true
		player.mo.spinbtn = true
		p.mo.dustOnGround = false
		p.mo.ghostjump = false
		player.mo.thokcheck = false
	end
	if PainCheck(player)
		player.mo.checkdamage = true
		player.mo.spinbtn = true
		p.mo.dustOnGround = false
		p.mo.ghostjump = false
		player.mo.thokcheck = false
	end
	if not PainCheck(player)
		if not P_IsObjectOnGround(player.mo) then
			p.mo.dustOnGround = true
			p.mo.ghoming = false
		else
			if P_IsObjectOnGround(player.mo) then
				player.mo.spinbtn = true
				if player.mo.eflags & MFE_JUSTHITFLOOR
					if p.mo.dustOnGround == true
						S_SpinDust(p, "JumpOnGround", p.mo.scale/2)
						S_StartSound(player.mo, sfx_s3k4c)
						p.mo.dustOnGround = false
					end
				end
			end
		end
		if player.mo and player.mo.valid
			if (player.mo.eflags & MFE_GOOWATER)
				player.mo.spinbtn = true
			end
			if player.cmd.buttons & BT_SPIN and not player.mo.spinbtn and not CBW_Battle
				if not P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_GALACTICJUMP) then
					P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
					P_SetObjectMomZ(player.mo, 22*FRACUNIT, false)
					S_StartSound(player.mo, sfx_thok)
					player.pflags = $1 | PF_THOKKED
					p.pflags = $1 & ~(PF_JUMPED|PF_SPINNING)
					player.charflags = $1|SF_NOSHIELDABILITY
					S_StartSound(player.mo, sfx_thokc)
					player.mo.thokcheck = true
					player.mo.spinbtn = true
				end
			end
			if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
				if player.mo.thokcheck == true
					player.crumbled = false
					player.charflags = $1 & ~SF_NOSHIELDABILITY
					S_SpinDust(p, "Stomp", p.mo.scale)
					P_RadiusAttack(player.mo, player.mo, 300*FRACUNIT)
					if player == consoleplayer
						P_StartQuake(50*FRACUNIT, 10)
					end
					S_StartSound(player.mo, sfx_pstop)
					for x=player.mo.x,player.mo.x+player.mo.radius,player.mo.radius
						for y=player.mo.y,player.mo.y+player.mo.radius,player.mo.radius
							local ss = R_PointInSubsector(x,y)
							for fof in ss.sector.ffloors()
								if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
									if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
										EV_CrumbleChain(ss.sector, fof)
										mo.state = S_PLAY_SPRING
										player.crumbled = true
										player.restoremomz = true
									end
								end
							end
						end
					end
					player.mo.thokcheck = false
				end
			else
				if player.mo.thokcheck == true
					player.panim = PA_DASH
					player.mo.state = S_PLAY_ROLL
					if player.powers[pw_justsprung]
					or (player.mo.eflags & MFE_SPRUNG)
						mo.state = S_PLAY_SPRING
						player.mo.thokcheck = false
					end
					if (player.mo.eflags & MFE_GOOWATER)
						mo.state = S_PLAY_SPRING
						player.mo.thokcheck = false
					end
					spawnThokParticle(player)
					if not player.mo.graveeffect
						P_SetObjectMomZ(player.mo, -2*FRACUNIT, true)
					else
						P_SetObjectMomZ(player.mo, -1*FRACUNIT/2, true)
					end	
				end
			end
		end
	end
	if player.restoremomz
		player.mo.momz = player.storemomzforcrumble
		player.restoremomz = nil
	end
	player.storemomzforcrumble = player.mo.momz
    if not (player.mo.tandashmode)
        player.mo.tandashmode = 0
    end
    if not (player.fixspeed)
        player.fixspeed = false
    end
	if not (player.mo.sound1)
		player.mo.sound1 = false
	end
	if not (player.mo.DASHMODESTATE)
		player.mo.DASHMODESTATE = false
	end
	if not PainCheck(player)
		if FixedHypot(player.rmomx, player.rmomy) > runspeed(player)
		or ((player.pflags & PF_STARTDASH) and player.mo.state == S_PLAY_SPINDASH)
			if player.mo.tandashmode < 3*TICRATE
				if (leveltime % 2 == 0)
					player.mo.tandashmode = $1 + 2
				end
			else
				player.charflags = $1|SF_RUNONWATER
				if player.mo.maxdashmode == true
					local dd = P_SpawnGhostMobj(p.mo)
					dd.blendmode = AST_ADD
					dd.fuse = TICRATE/5
					dd.destscale = 0
					dd.color = player.mo.color
					dd.colorized = true
					if (leveltime & 3) == 1 or player.mo.tics % 2
						local elaura = P_SpawnMobjFromMobj(player.mo,
						P_RandomRange(-20, 20)*FRACUNIT,
						P_RandomRange(-20, 20)*FRACUNIT,
						P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
						elaura.state = P_RandomRange(S_ELECTROSPEED0, S_ELECTROSPEED2)
						elaura.blendmode = AST_ADD
						elaura.fuse = 8
						elaura.destscale = 0
						elaura = player.mo.scale/2
						if not (player.mo.eflags & MFE_TOUCHWATER)
							if P_IsObjectOnGround(player.mo) and not player.isxmomentum then
								local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
								dust.momx = cos(player.mo.angle)*-10+(P_RandomRange(-10,10)*FRACUNIT)
								dust.momy = sin(player.mo.angle)*-10+(P_RandomRange(-10,10)*FRACUNIT)
								dust.momz = player.speed/TICRATE
								dust.frame = leveltime%4
							end	
						end
					end
					if not S_SoundPlaying(player.mo,sfx_gbost)
						S_StartSound(player.mo, sfx_gbost)
					end
				end
				if P_IsObjectOnGround(player.mo) then
					local dustcheck
					if player.powers[pw_super]
						dustcheck = MT_SUPERSPARK
					elseif player.mo.maxdashmode == true
						dustcheck = MT_DUST
					else
						if (player.mo.eflags & MFE_TOUCHWATER)
							dustcheck = MT_NULL
						else
							dustcheck = MT_SPINDUST
						end
					end
					local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, dustcheck)
					dust.momx = cos(player.mo.angle)*-10+(P_RandomRange(-10,10)*FRACUNIT)
					dust.momy = sin(player.mo.angle)*-10+(P_RandomRange(-10,10)*FRACUNIT)
					dust.momz = player.speed/TICRATE
					if not player.powers[pw_super]
						dust.frame = leveltime%4
					elseif player.mo.maxdashmode == true
						dust.frame = leveltime%4
					end
					if player.mo.maxdashmode == true
						dust.state = S_ELECTROSPEED0
						dust.scale = player.mo.scale/2
						dust.blendmode = AST_ADD
					end
				end
				if (leveltime % 8 == 1)
					local flash = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GRAVEEFFECTWAY)
					if flash and flash.valid then
						flash.target = player.mo
						flash.blendmode = AST_ADD
						flash.color = player.mo.color
						flash.colorized = true
						flash.fuse = 11
					end
				end
				local ofsts_tics = min(TICRATE, leveltime)
				local ofsts = FixedMul((ofsts_tics * FRACUNIT) / TICRATE, FRACUNIT*2)
				local f = FixedMul(2*player.mo.scale, sin(FixedAngle(P_RandomRange(180, 360)*FRACUNIT)))
				local ka = P_SpawnGhostMobj(player.mo)
				if leveltime % 5 == 0
					ka.color = player.mo.color
					ka.colorized = true
					ka.fuse = 5
				else
					ka.blendmode = AST_ADD
					ka.fuse = 3
				end
				ka.height = player.mo.height
				ka.angle = player.drawangle
				ka.color = player.mo.color
				ka.target = player.mo
				ka.flags2 = player.mo.flags2
				ka.spritexoffset = ofsts * (((leveltime%4) >= 2) and -1 or 1)
				P_MoveOrigin(ka, player.mo.x + f, player.mo.y + f, player.mo.z)
				if player.normalspeed <= 90*FRACUNIT
					if (player.pflags & PF_STARTDASH) and player.mo.state == S_PLAY_SPINDASH
						if player.normalspeed <= 80*FRACUNIT
							player.normalspeed = $1 + 1*FRACUNIT/5
						end
					else
						player.normalspeed = $1 + 1*FRACUNIT/5
					end
					player.mo.maxdashmode = false
				end
				if FixedHypot(player.rmomx, player.rmomy) < FixedMul(36*FRACUNIT, player.mo.scale)
					if player.mo.maxdashmode == true
						if player.mo.state == S_PLAY_DASH
							if FixedHypot(player.rmomx, player.rmomy) >= runspeed(player)
								player.mo.state = S_PLAY_RUN
							else
								player.mo.state = S_PLAY_WALK
							end
						end
						player.normalspeed = 36*FRACUNIT
						player.mo.maxdashmode = false
					end
					if S_SoundPlaying(mo, sfx_gbost)
						S_StopSoundByID(mo, sfx_gbost)
					end
				end
				if player.normalspeed >= 90*FRACUNIT
					if player.panim == PA_RUN and player.mo.state ~= S_PLAY_DASH
						player.mo.DASHMODESTATE = true
						player.mo.state = S_PLAY_DASH
					end
					if not player.mo.maxdashmode
						player.normalspeed = 100*FRACUNIT
						P_Thrust(player.mo, player.mo.angle, player.normalspeed/4)
						S_StartSound(player.mo, sfx_bldash)
						S_StartSound(player.mo, sfx_gbost)
						local thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
						thok.fuse = TICRATE/4
						thok.scale = thok.fuse+p.mo.scale
						thok.state = S_MAXSPEED0
						thok.color = p.mo.color
						thok.colozied = true
						thok.blendmode = AST_ADD
						player.mo.maxdashmode = true
						if player == consoleplayer
							P_StartQuake(25*FRACUNIT, 10)
						end
					end
				end
				if not player.fixspeed
					player.fixspeed = true
				end
				if not player.mo.sound1
					S_StartSound(player.mo, sfx_hmsnob)
					if player == consoleplayer
						P_StartQuake(25*FRACUNIT, 10)
					end
					player.mo.sound1 = true
				end
			end
		else
			player.mo.maxdashmode = false
			if S_SoundPlaying(mo, sfx_gbost)
                S_StopSoundByID(mo, sfx_gbost)
            end
			if player.mo.DASHMODESTATE == true
				if player.mo.state == S_PLAY_DASH
					player.mo.state = S_PLAY_WALK
				end
				player.mo.DASHMODESTATE = false
			end
			if player.mo.sound1 == true
				S_StartSound(player.mo, sfx_kc65)
				player.mo.sound1 = false
			end
			if player.fixspeed == true
				player.normalspeed = originalspeed.normalspeed
				player.runspeed = originalspeed.runspeed
				player.charflags = $1 & ~SF_RUNONWATER
				player.fixspeed = false
			end
			if player.mo.tandashmode > 0
				player.mo.tandashmode = $1 - 1
			end
		end
	else
		player.mo.maxdashmode = false
		if S_SoundPlaying(mo, sfx_gbost)
			S_StopSoundByID(mo, sfx_gbost)
        end
		if player.mo.DASHMODESTATE == true
			player.mo.DASHMODESTATE = false
		end
		if player.mo.sound1 == true
			player.mo.sound1 = false
		end
		if player.fixspeed == true
			player.normalspeed = originalspeed.normalspeed
			player.runspeed = originalspeed.runspeed
			player.charflags = $1 & ~SF_RUNONWATER
			player.fixspeed = false
		end
		if player.mo.tandashmode > 0
			player.mo.tandashmode = 0
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "gsonic")
		if player.mo.maxdashmode == true or player.mo.thokcheck == true or player.mo.gravecheck == true then
			return true
		end
    end
	if player.drifting >= 1 then
		return true
	end
end)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "gsonic") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.mo.maxdashmode
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "gsonic") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.mo.maxdashmode
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("AbilitySpecial", function(p)
	if p.mo.skin == "gsonic"
		if not (p.pflags & PF_THOKKED)
			if not p.powers[pw_super] then
				S_StartSound(p.mo, sfx_sfdsh)
			elseif p.powers[pw_super] then
				S_StartSound(p.mo, sfx_sdsh)
			end
			p.pflags = $1 & ~(PF_JUMPED|PF_SPINNING)
			S_SpinDust(p, "Stomp", p.mo.scale)
			p.mo.state = S_PLAY_GALACTICJUMP
			P_DoJump(p, false)
			p.pflags = $1|PF_THOKKED
		end
	end		
end)


/*
addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.skin == "gsonic"
	and player.playerstate == PST_LIVE
	and not player.exiting
	and player.speed > 5*player.mo.scale
	and player.powers[pw_super]
	and P_MobjFlip(player.mo)*player.mo.momz <= 0
		player.mo.thokcheck = false
		player.mo.ghostjump = false
		if player.speed >= FixedMul(player.runspeed, player.mo.scale)
			player.mo.state = S_PLAY_FLOAT_RUN
		else
			player.mo.state = S_PLAY_FLOAT
		end
		player.mo.momz = 0
		player.pflags = $&~(PF_STARTJUMP|PF_SPINNING)
	end
end)*/

